    processor   6502

	ORG $1001
	DC.W $100B,0
	DC.B $9E,"4109",0,0,0	; SYS4107
	JMP main
	
	

main SUBROUTINE	
	SEI		
	STA $FF3F
	
	LDA #$00
	STA $FF19
	LDA #$11
	STA $FF15
	
	JSR mainirq_setup

    CLI
	
	
mainloop SUBROUTINE
		
	LDA #$7F	; query keyboard
	STA $FD30
	STA $FF08
	LDA $FF08
	AND #$10	; check for space pressed
	BNE mainloop

	SEI
	STA $FF3E	; enable ROM
	JMP $FFF6	; reset
	
mainirq	SUBROUTINE
	PHA
	TXA
	PHA
	TYA
	PHA

	LDA $FF09
	STA $FF09
	
	INC $FF19
	
	LDX #$01
	JSR am_songtick
	JSR am_out

	DEC $FF19

	JSR mainirq_setup

	
mainirq_exit
	PLA
	TAY
	PLA
	TAX
	PLA
	RTI	
	
	
mainirq_setup SUBROUTINE

	LDA #mainirq & 255
	STA $FFFE
	LDA #mainirq >> 8
	STA $FFFF

	LDA parity
	BEQ .even

.odd	
	LDA #$00
	STA parity
	LDA #$02
	STA $FF0A
	LDA #$Cd
	STA $FF0B
	RTS
	
	
	
.even
	INC parity
	LDA #$02
	STA $FF0A
	LDA #$00
	STA $FF0B
	
	RTS
	
parity
	dc.b $00	


	ORG $1200
	
	include "music.asm"
		
	

